! Print permutations of a string
! Nils M Holm, 2003
! See the file LICENSE for conditions of use.

module permute(t3x, string);

object	t[t3x], str[string];

const	MAX = 10;	! Maximum string length

writes(s) t.write(T3X.SYSOUT, s, str.length(s));

! Permute the last n-k characters of the string s,
! where n is the length of s; print all permutations

permute(s, n, k) do var i, j, u, nl::3;
	ie (k = n) do
		t.write(T3X.SYSOUT, s, n);
		writes(t.newline(nl));
	end
	else for (i=0, n-k) do
		permute(s, n, k+1);
		u := s::k;
		t.memcopy(@s::k, @s::k+1, n-k-1);
		s::(n-1) := u;
	end
end

do var input::MAX+1, k;
	k := t.read(T3X.SYSIN, input, MAX+1);	! Read string
	k := k-1;				! Strip newline character
	if (k > 0 /\ input::(k-1) = '\r')	! Strip CR, if present
		k := k-1;
	if (k > 0) input::k := 0;		! Delimit string
	if (k > 0) permute(input, k, 0);
end
