! Print some prime numbers.
! Nils M Holm, 2004
! See the file LICENSE for conditions of use.

class prime_list(t3x, util)

 object	u[util];

 public const	POOLSIZE = 3500;

 var	Primes[POOLSIZE];
 var	Limit;

 public reset() do
	Primes[0] := 2;
	Limit := 1;
 end

 sqrt(q) do var x;
	x := q;
	while (1) do
		if (x*x <= q /\ (x+1)*(x+1) >= q) leave;
		x := (x+q/x)/2;
	end
	return x;
 end

 isPrime(x) do var i, k;
	k := sqrt(x);
	for (i=0, Limit) do
		if (Primes[i] > k) return 1;
		if (x mod Primes[i] = 0)
			return 0;
	end
	return 1;
 end

 public next() do var x;
	x := Primes[Limit-1]+1;
	if (x mod 2 = 0) x := x+1;
	while (\isPrime(x)) x := x+2;
	if (Limit >= POOLSIZE) do
		u.writef(T3X.SYSERR, "Out of memory\n", 0);
		halt 1;
	end
	Primes[Limit] := x;
	Limit := Limit + 1;
	return x;
 end

end

module primes(util, prime_list);

object	u[util];
object	pl[prime_list];

do var i;
	pl.reset();
	for (i=0, PRIME_LIST.POOLSIZE-1)
		u.printf("%d\n", [(pl.next())]);
end
